import { Component } from 'react';
import { getWxConfig } from '../api/index';
import { APP_ID } from '../config/index';

class WxWrap extends Component {
  constructor(props, context) {
    super(props, context);
    this.state = {
      wxDone: false,
    };
    this.wxConfigHandle();
  }

  wxConfigHandle = () => {
    const wx = window.wx;
    return new Promise((resolve, reject) => {
      let url = window.location.href.split('#')[0];
      const u = navigator.userAgent;
      const isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
      if (isIOS) {
        url = window.location.origin + '/';
      }
      getWxConfig({
        url: encodeURIComponent(url),
      })
        .then(res => {
          const data = res.data;
          wx.config({
            // debug: true, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
            appId: APP_ID, // 必填，公众号的唯一标识
            timestamp: data.timestamp, // 必填，生成签名的时间戳
            nonceStr: data.nonceStr, // 必填，生成签名的随机串
            signature: data.signature, // 必填，签名
            jsApiList: ['scanQRCode'], // 必填，需要使用的JS接口列表
          });
        })
        .catch(err => {
          console.log(err);
          reject(err);
        });
      wx.ready(() => this.wxReadyHandle(resolve));
      wx.error(reject);
    });
  };
  wxReadyHandle = done => {
    this.setState({
      wxDone: true,
    });
    done();
  };
  render() {
    const { render } = this.props;
    return render({ ...this.state, wxConfigHandle: this.wxConfigHandle });
  }
}

export default WxWrap;
