import fetch from './fetch';
import store from '../store/index';

export const wxLogin = entity =>
  fetch({
    url: '/weixinLogin',
    method: 'post',
    data: entity,
  });

export const login = entity =>
  fetch({
    url: '/login',
    method: 'post',
    data: entity,
  }).then(res => {
    // store.next('123');
    console.log(res);
    const {
      data: { token },
    } = res;
    store.updateToken(token);
    return res;
  });

export const testWater = entity =>
  fetch({
    url: `/devices/${entity.deviceCode}/testWater`,
    method: 'post',
    data: entity,
  });

export const checkWater = entity =>
  fetch({
    url: `/devices/${entity.deviceCode}/waterVerification`,
    method: 'post',
    data: entity,
  });

export const fetchRate = deviceCode =>
  fetch({
    url: `/devices/${deviceCode}/rate`,
    // data: entity,
  });

export const activateRate = entity =>
  fetch({
    url: `/devices/${entity.deviceCode}/rate`,
    method: 'post',
    data: entity,
  });

export const getPositions = entity =>
  fetch({
    url: `/devices/${entity.deviceCode}/positions`,
  });

export const getPositionsList = entity =>
  fetch({
    url: '/positions/unusing',
    params: entity,
  });

export const bindEquipment = entity =>
  fetch({
    url: `/devices/${entity.deviceCode}/binding`,
    method: 'post',
    data: entity,
  });
export const unbindEquipment = entity =>
  fetch({
    url: `/devices/${entity.deviceCode}/unbinding`,
    method: 'post',
    data: entity,
  });

export const getWxConfig = entity =>
  fetch({
    url: '/richScan',
    params: entity,
  });
export const unbindKeyboard = entity =>
  fetch({
    url: `/devices/${entity.deviceCode}/keyboard/unbinding`,
    method: 'post',
    data: entity,
  });
export const getUnbindKeyboardResult = entity =>
  fetch({
    url: `/devices/${entity.deviceCode}/keyboard/unbinding`,
    params: entity,
  });

  // 获取鼓风机到期时间
  export const getDuration = entity =>
  fetch({
    url: `/devices/${entity.deviceCode}/duration`,
    params: entity,
  });
  // 清楚鼓风机剩余时长
  export const cleanDuration = entity =>
  fetch({
    url: `/devices/${entity.deviceCode}/${entity.side}/duration/clean`,
    method: 'post',
    params: entity,
  });
  // 延长剩余时长
  export const delayedDuration = entity =>
  fetch({
    url: `/devices/${entity.deviceCode}/${entity.side}/duration/add/${entity.day}`,
    method: 'post',
    params: entity,
  });
  // 缩短剩余时长
  export const reduceDuration = entity =>
  fetch({
    url: `/devices/${entity.deviceCode}/${entity.side}/duration/reduce/${entity.day}`,
    method: 'post',
    params: entity,
  });
