import React, { createContext, useState } from 'react';

function is_weixn() {
  var ua = navigator.userAgent.toLowerCase();
  return ua.match(/MicroMessenger/i) === 'micromessenger';
}

export const initUserinfo = {
  isWx: is_weixn(),
  userId: '123',
  token: '',
  campusId: '',
  campusName: '',
  barcode: '',
  position: {
    id: null,
    position: null,
    mode: null,
    isBind: false,
    deviceType: null,
  },
};

export const UserContext = createContext();

export const UserProvider = props => {
  const [userinfo, setUserinfo] = useState(initUserinfo);

  return (
    <UserContext.Provider
      value={{
        userinfo: userinfo,
        updateUserInfo: val =>
          setUserinfo({
            ...userinfo,
            ...val,
          }),
      }}>
      {props.children}
    </UserContext.Provider>
  );
};

export default UserContext;
